from ..client_interface.vm.instance import InstanceInterface
import openstack


class OSInstanceInterface(InstanceInterface):

    def __init__(self, cloud):
        super().__init__(self)
        self.openstack = openstack.connect(cloud)

    def create_vm_from_template(self, name, resource, template):
        flavor = self.openstack.compute.find_flavor(name)
        if not flavor:
            flavor = self.openstack.compute.Flavor(nam=name, ram=resource.ram, vcpus=resource.cpu)

        image = self.openstack.compute.find_image(template)
        if not image:
            raise ValueError("The template not found")

        new_server = self.openstack.compute.create_server(name=name,
                                                          flavorRef=flavor.id,
                                                          imageRef=image.id)

        new_server = conn.compute.wait_for_server(new_server)

        return new_server
